#include <iostream>
#include <fstream>
#include <string>
#include <cstdlib>
using namespace std;

void done(double score, string message) {
	cout << score << "\n";
	cerr << message << "\n";
	exit(0);
}

int main(int argc, const char *argv[]) {
	if (argc != 4) {
		cerr << "Usage: " << argv[0] << " input_file hint_file output_file\n";
		return 0;
	}
	ifstream in(argv[1]), hint(argv[2]), out(argv[3]);

	int n;
	in >> n;

	int p1;
	hint >> p1;

	int p2;
	out >> p2;
	if (!out) {
		done(0, "Invalid output file");
	}
	if (0 > p2 || p2 > n) {
		// we accept 0 to mean drawing the line to the left of all baskets
		done(0, "Wrong answer");
	}
	string tmp;
	out >> tmp;
	if (out) {
		done(0, "Invalid output file");
	}

	int s1a = 0, s1b = 0, s2a = 0, s2b = 0;
	for (int i = 0; i < n; ++i) {
		int k;
		in >> k;
		if (i < p1) s1a += k; else s1b += k;
		if (i < p2) s2a += k; else s2b += k;
	}

	if (abs(s2a - s2b) < abs(s1a - s1b)) {
		done(1, "Wrong hint!");
	} else if (abs(s2a - s2b) == abs(s1a - s1b)) {
		done(1, "OK");
	} else {
		done(0, "Wrong answer");
	}
	return 0;
}
