#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <fstream>

using namespace std;

typedef long long ll;

const int MAX_K = 45;
const int HALF = 18;
const ll MAX_N = 1e18 + 5;

ll parties [MAX_K];

int last_leq (ll x, const vector<ll> &arr) {
  // kahendotsing -- leiab sorteeritud vektoris 'arr' viimase indeksi i nii, et arr[i] <= x
  if (arr[0] > x) {
    return -1;
  }

  int ans = 0;
  for (int k = 1 << HALF; k != 0; k /= 2) {
    if (ans + k < (int) arr.size() && arr[ans + k] <= x) {
      ans += k;
    }
  }
  return ans;
}

int main () {  
  ifstream fin ("koalsis.txt");
  ofstream fout ("koalval.txt");
  
  ll seatc;
  int partyc;
  fin >> seatc >> partyc;

  for (int i = 0; i < partyc; i++) {
    fin >> parties[i];
  }

  sort(parties, parties + partyc, greater<ll> ());
  vector<ll> big_subsets;
  
  ll ans = 0;
  for (int i = 1; i < 1 << min(HALF, partyc); i++) {
    ll smallest_size = MAX_N;
    ll sum_size = 0;
    for (int j = 0; j < min(HALF, partyc); j++) {
      if (i & 1 << j) {
        sum_size += parties[j];
        smallest_size = min(smallest_size, parties[j]);
      }
    }

    if ((sum_size - smallest_size < seatc / 2 + 1) && (sum_size >= seatc / 2 + 1)) {
      ans++;
    }
    big_subsets.push_back(sum_size);
  }

  sort(big_subsets.begin(), big_subsets.end());

  // cerr << ans << endl;
  if (HALF < partyc) {
    for (int i = 1; i < 1 << (partyc - HALF); i++) {
      ll smallest_size = MAX_N;
      ll sum_size = 0;
      for (int j = 0; j < (partyc - HALF); j++) {
        if (i & 1 << j) {
          sum_size += parties[j + HALF];
          smallest_size = min(smallest_size, parties[j + HALF]);
        }
      }

      if ((sum_size - smallest_size < seatc / 2 + 1) && (sum_size >= seatc / 2 + 1)) {
        ans++;
      }

      ans += last_leq(seatc / 2 - sum_size + smallest_size, big_subsets)
        - last_leq(seatc / 2 + 1 - sum_size - 1, big_subsets);
    }
  }

  fout << ans << endl;
}
