#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <sstream>
#include <cstdlib>
using namespace std;

void done(double score, string message) {
	cout << score << "\n";
	cerr << message << "\n";
	exit(0);
}

int main(int argc, const char *argv[]) {
	if (argc != 4) {
		cerr << "Usage: " << argv[0] << " input_file hint_file output_file\n";
		return 0;
	}
	ifstream in(argv[1]), hint(argv[2]), out(argv[3]);
	string s, t;

	int r, v;
	in >> r >> v;
	vector<string> map(r);
	for (int i = 0; i < r; ++i) {
		in >> map[i];
	}

	int n1;
	hint >> n1;

	int n2 = -1;
	if (getline(out, s)) {
		istringstream ss(s);
		ss >> n2;
		if (!ss || ss >> t) {
			n2 = -1;
		}
	}

	int n3 = -1;
	int ns = 0;
	int rp = 0, vp = 0;
	int ri, vi;
	bool ok = true;
	while (getline(out, s)) {
		istringstream ss(s);
		ss >> ri >> vi;
		if (!ss || ss >> t) {
			ok = false;
			break;
		}
		++n3;
		if (1 > ri || ri > r) {
			ok = false;
			break;
		}
		if (1 > vi || vi > v) {
			ok = false;
			break;
		}
		--ri; --vi;
		if (n3 == 0) {
			if (map[ri][vi] != '@') {
				ok = false;
				break;
			}
		} else {
			if (map[ri][vi] == '#') {
				ok = false;
				break;
			}
			int dr = abs(ri - rp), dv = abs(vi - vp);
			if (dr == 1 && dv == 2 || dr == 2 && dv == 1) {
				// nothing here
			} else if (dr == 1 && dv == 3 || dr == 3 && dv == 1) {
				++ns;
			} else {
				ok = false;
				break;
			}
		}
		rp = ri; vp = vi;
	}
	if (map[rp][vp] != '*') {
		ok = false;
	}
	if (ns > 1) {
		ok = false;
	}

	if (n1 == n2 && n1 == n3 && ok) {
		done(1.0, "OK");
	} else if (n1 == n2) {
		done(0.5, "Length OK, wrong path");
	} else if (n1 == n3 && ok) {
		done(0.5, "Wrong length, path OK");
	} else if (n2 == n3 && ok) {
		done(0.5, "Suboptimal");
	} else {
		done(0.0, "Wrong answer");
	}
	return 0;
}
