#include <iostream>
#include <vector>
#include <deque>
#include <string>
#include <cstdlib>
using namespace std;

struct kaik { int rea_nihe, veeru_nihe, super; };

const vector<kaik> tavakaigud = {{-2, -1, 0}, {-2, 1, 0}, {-1, -2, 0}, {-1, 2, 0}, {1, -2, 0}, {1, 2, 0}, {2, -1, 0}, {2, 1, 0}};
const vector<kaik> superkaigud = {{-3, -1, 1}, {-3, 1, 1}, {-1, -3, 1}, {-1, 3, 1}, {1, -3, 1}, {1, 3, 1}, {3, -1, 1}, {3, 1, 1}};

struct olek { int kaugus = 1000000; kaik suund; };
struct koht { int rida, veerg, super; };

int main(int argc, const char *argv[]) {
	if (argc != 5) {
		cerr << "Usage: " << argv[0] << " rows cols blocked supers\n";
	}
	int ridu = atoi(argv[1]);
	int veerge = atoi(argv[2]);
	int blokke = atoi(argv[3]);
	int super = atoi(argv[4]);

	string laud[ridu];
	for (int rida = 0; rida < ridu; ++rida) {
		laud[rida] = string(veerge, '.');
	}

	srand(ridu + veerge + blokke + super);
	for (int i = 0; i < blokke; ++i) {
		for ( ; ; ) {
			int rida = rand() % ridu;
			int veerg = rand() % veerge;
			if (laud[rida][veerg] == '.') {
				laud[rida][veerg] = '#';
				break;
			}
		}
	}
	for ( ; ; ) {
		int rida = rand() % ridu;
		int veerg = rand() % veerge;
		if (laud[rida][veerg] == '.') {
			laud[rida][veerg] = '@';
			break;
		}
	}

	koht start;
	olek olekud[ridu][veerge][2];
	deque<koht> too;
	for (int rida = 0; rida < ridu; ++rida) {
		for (int veerg = 0; veerg < veerge; ++veerg) {
			if (laud[rida][veerg] == '@') {
				olekud[rida][veerg][0].kaugus = 0;
				start = koht{rida, veerg, 0};
				too.push_back(start);
			}
		}
	}

	while (!too.empty()) {
		koht jooksev = too.front();
		too.pop_front();
		for (kaik uus : tavakaigud) {
			int rida = jooksev.rida + uus.rea_nihe, veerg = jooksev.veerg + uus.veeru_nihe;
			if (rida < 0 || rida >= ridu || veerg < 0 || veerg >= veerge) {
				// laualt väljas
			} else if (laud[rida][veerg] == '#') {
				// blokeeritud ruudul
			} else {
				// käidaval ruudul
				for (int super = 0; super < 2; ++super) {
					if (olekud[rida][veerg][super].kaugus > olekud[jooksev.rida][jooksev.veerg][super].kaugus + 1) {
						olekud[rida][veerg][super].kaugus = olekud[jooksev.rida][jooksev.veerg][super].kaugus + 1;
						olekud[rida][veerg][super].suund = uus;
						too.push_back(koht{rida, veerg, super});
					}
				}
			}
		}
		for (kaik uus : superkaigud) {
			int rida = jooksev.rida + uus.rea_nihe, veerg = jooksev.veerg + uus.veeru_nihe;
			if (rida < 0 || rida >= ridu || veerg < 0 || veerg >= veerge) {
				// laualt väljas
			} else if (laud[rida][veerg] == '#') {
				// blokeeritud ruudul
			} else {
				// käidaval ruudul
				if (olekud[rida][veerg][1].kaugus > olekud[jooksev.rida][jooksev.veerg][0].kaugus + 1) {
					olekud[rida][veerg][1].kaugus = olekud[jooksev.rida][jooksev.veerg][0].kaugus + 1;
					olekud[rida][veerg][1].suund = uus;
					too.push_back(koht{rida, veerg, 1});
				}
			}
		}
	}

	olekud[start.rida][start.veerg][1].kaugus = 0;
	koht finish = start;
	for (int rida = 0; rida < ridu; ++rida) {
		for (int veerg = 0; veerg < veerge; ++veerg) {
			if (super == 0 && olekud[rida][veerg][0].kaugus != 1000000 &&
					olekud[rida][veerg][0].kaugus <= olekud[rida][veerg][1].kaugus &&
					olekud[rida][veerg][0].kaugus > olekud[finish.rida][finish.veerg][0].kaugus) {
				finish = koht{rida, veerg, 0};
			}
			if (super == 1 && olekud[rida][veerg][1].kaugus != 1000000 &&
					olekud[rida][veerg][1].kaugus < olekud[rida][veerg][0].kaugus &&
					olekud[rida][veerg][1].kaugus > olekud[finish.rida][finish.veerg][1].kaugus) {
				finish = koht{rida, veerg, 1};
			}
		}
	}
	laud[finish.rida][finish.veerg] = '*';
	cerr << olekud[finish.rida][finish.veerg][super].kaugus << '\n';

	cout << ridu << ' ' << veerge << '\n';
	for (string rida : laud) {
		cout << rida << '\n';
	}
}
