// efektiivne lahendus laiuti läbimisega

#include <iostream>
#include <fstream>
#include <vector>
#include <deque>
#include <string>
using namespace std;

struct kaik { int rea_nihe, veeru_nihe, super; };

const vector<kaik> tavakaigud = {{-2, -1, 0}, {-2, 1, 0}, {-1, -2, 0}, {-1, 2, 0}, {1, -2, 0}, {1, 2, 0}, {2, -1, 0}, {2, 1, 0}};
const vector<kaik> superkaigud = {{-3, -1, 1}, {-3, 1, 1}, {-1, -3, 1}, {-1, 3, 1}, {1, -3, 1}, {1, 3, 1}, {3, -1, 1}, {3, 1, 1}};

ifstream sis("ratsusis.txt");
ofstream val("ratsuval.txt");

struct olek { int kaugus = 1000000; kaik suund; };
struct koht { int rida, veerg, super; };

int main() {
	int ridu, veerge;
	sis >> ridu >> veerge;
	string laud[ridu];
	for (int rida = 0; rida < ridu; ++rida) {
		sis >> laud[rida];
	}

	olek olekud[ridu][veerge][2];
	deque<koht> too;
	for (int rida = 0; rida < ridu; ++rida) {
		for (int veerg = 0; veerg < veerge; ++veerg) {
			if (laud[rida][veerg] == '@') {
				olekud[rida][veerg][0].kaugus = 0;
				too.push_back(koht{rida, veerg, 0});
			}
		}
	}

	while (!too.empty()) {
		koht jooksev = too.front();
		too.pop_front();
		for (kaik uus : tavakaigud) {
			int rida = jooksev.rida + uus.rea_nihe, veerg = jooksev.veerg + uus.veeru_nihe;
			if (rida < 0 || rida >= ridu || veerg < 0 || veerg >= veerge) {
				// laualt väljas
			} else if (laud[rida][veerg] == '#') {
				// blokeeritud ruudul
			} else {
				// käidaval ruudul
				for (int super = 0; super < 2; ++super) {
					if (olekud[rida][veerg][super].kaugus > olekud[jooksev.rida][jooksev.veerg][super].kaugus + 1) {
						olekud[rida][veerg][super].kaugus = olekud[jooksev.rida][jooksev.veerg][super].kaugus + 1;
						olekud[rida][veerg][super].suund = uus;
						too.push_back(koht{rida, veerg, super});
					}
				}
			}
		}
		for (kaik uus : superkaigud) {
			int rida = jooksev.rida + uus.rea_nihe, veerg = jooksev.veerg + uus.veeru_nihe;
			if (rida < 0 || rida >= ridu || veerg < 0 || veerg >= veerge) {
				// laualt väljas
			} else if (laud[rida][veerg] == '#') {
				// blokeeritud ruudul
			} else {
				// käidaval ruudul
				if (olekud[rida][veerg][1].kaugus > olekud[jooksev.rida][jooksev.veerg][0].kaugus + 1) {
					olekud[rida][veerg][1].kaugus = olekud[jooksev.rida][jooksev.veerg][0].kaugus + 1;
					olekud[rida][veerg][1].suund = uus;
					too.push_back(koht{rida, veerg, 1});
				}
			}
		}
	}

	deque<koht> tee;
	for (int rida = 0; rida < ridu; ++rida) {
		for (int veerg = 0; veerg < veerge; ++veerg) {
			if (laud[rida][veerg] == '*') {
				if (olekud[rida][veerg][0].kaugus <= olekud[rida][veerg][1].kaugus) {
					cout << "Ainult tavakäigud\n";
					tee.push_front(koht{rida, veerg, 0});
				} else {
					cout << "Superkäik\n";
					tee.push_front(koht{rida, veerg, 1});
				}
			}
		}
	}
	while (laud[tee.front().rida][tee.front().veerg] != '@') {
		koht jooksev = tee.front();
		kaik viimane = olekud[jooksev.rida][jooksev.veerg][jooksev.super].suund;
		tee.push_front(koht{jooksev.rida - viimane.rea_nihe, jooksev.veerg - viimane.veeru_nihe, jooksev.super - viimane.super});
	}
	val << tee.size() - 1 << '\n';
	for (koht jooksev : tee) {
		val << jooksev.rida + 1 << ' ' << jooksev.veerg + 1 << '\n';
	}
}
