// ebaoptimaalne lahendus kõigi variantide sügavuti läbimisega

#include <fstream>
#include <vector>
#include <string>
using namespace std;

struct kaik { int rea_nihe, veeru_nihe; };

const vector<kaik> tavakaigud = {{-2, -1}, {-2, 1}, {-1, -2}, {-1, 2}, {1, -2}, {1, 2}, {2, -1}, {2, 1}};
const vector<kaik> superkaigud = {{-3, -1}, {-3, 1}, {-1, -3}, {-1, 3}, {1, -3}, {1, 3}, {3, -1}, {3, 1}};

ifstream sis("ratsusis.txt");
ofstream val("ratsuval.txt");

int ridu, veerge;
vector<string> laud;

struct koht { int rida, veerg; };

vector<koht> parim_tee;
vector<koht> tee;

void otsi(int rida, int veerg, bool super_tehtud) {
	if (rida < 0 || rida >= ridu || veerg < 0 || veerg >= veerge) {
		// laualt väljas
	} else if (laud[rida][veerg] == '*') {
		// sihtkohas
		tee.push_back(koht{rida, veerg});
		if (parim_tee.size() > tee.size() || parim_tee.size() == 0) {
			parim_tee = tee;
		}
		tee.pop_back();
	} else if (laud[rida][veerg] == '.') {
		// vabal ruudul
		tee.push_back(koht{rida, veerg});
		laud[rida][veerg] = 'x';
		for (kaik uus : tavakaigud) {
			otsi(rida + uus.rea_nihe, veerg + uus.veeru_nihe, super_tehtud);
		}
		if (!super_tehtud) {
			for (kaik uus : superkaigud) {
				otsi(rida + uus.rea_nihe, veerg + uus.veeru_nihe, true);
			}
		}
		laud[rida][veerg] = '.';
		tee.pop_back();
	}
}

int main() {
	sis >> ridu >> veerge;
	laud.resize(ridu);
	for (int rida = 0; rida < ridu; ++rida) {
		sis >> laud[rida];
	}
	for (int rida = 0; rida < ridu; ++rida) {
		for (int veerg = 0; veerg < veerge; ++veerg) {
			if (laud[rida][veerg] == '@') {
				laud[rida][veerg] = '.';
				otsi(rida, veerg, false);
				laud[rida][veerg] = '@';
			}
		}
	}

	val << parim_tee.size() - 1 << '\n';
	for (koht jooksev : parim_tee) {
		val << jooksev.rida + 1 << ' ' << jooksev.veerg + 1 << '\n';
	}
}
