#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
using namespace std;

int main(int argc, const char *argv[]) {
	if (argc != 4) {
		cerr << "Usage: " << argv[0] << " input_file hint_file output_file\n";
		return 0;
	}
	ifstream in(argv[1]), hint(argv[2]), out(argv[3]);
	string s, t;
	double score = 0;
	string message;

	long long n, m;
	in >> n >> m;

	long long s1, k1;
	hint >> s1 >> k1;

	if (!getline(out, s)) {
		message += "invalid SK";
	} else {
		long long s2, k2;
		istringstream ss(s);
		ss >> s2 >> k2;
		if (!ss || ss >> t) {
			message += "invalid SK";
		} else if (s1 != s2 || k1 != k2) {
			message += "wrong SK";
		} else {
			message += "SK OK";
			score += 0.5;
		}
	}

	if (!getline(out, s)) {
		message += ", invalid 1st";
	} else {
		istringstream ss(s);
		int p1, p2;
		bool ok = true;
		for (int i = 0; i < n && ok; ++i) {
			hint >> p1;
			ss >> p2;
			if (!ss) {
				message += ", invalid 1st";
				ok = false;
			} else if (p1 != p2) {
				message += ", wrong 1st";
				ok = false;
			}
		}
		if (ok) {
			if (ss >> t) {
				message += ", invalid 1st";
			} else {
				message += ", 1st OK";
				score += 0.25;
			}
		} else {
			getline(hint, t);
		}
	}

	if (!getline(out, s)) {
		message += ", invalid Mth";
	} else {
		istringstream ss(s);
		int p1, p2;
		bool ok = true;
		for (int i = 0; i < n && ok; ++i) {
			hint >> p1;
			ss >> p2;
			if (!ss) {
				message += ", invalid Mth";
				ok = false;
			} else if (p1 != p2) {
				message += ", wrong Mth";
				ok = false;
			}
		}
		if (ok) {
			if (ss >> t) {
				message += ", invalid Mth";
			} else {
				message += ", Mth OK";
				score += 0.25;
			}
		} else {
			getline(hint, t);
		}
	}

	cout << score << "\n";
	cerr << message << "\n";
	return 0;
}
