import heapq

INF = 1 << 70
MAX_N = int(1e5 + 5)
MOD = int(1e9 + 7)

def inf_mul (p, q):
    return min(INF, p * q)

def inf_add (p, q):
    return min(INF, p + q)

def mod_mul (p, q):
    return (p * q) % MOD

def mod_add (p, q):
    return (p + q) % MOD

fact_inf = [1 for i in range(MAX_N)]
fact_mod = [1 for i in range(MAX_N)]
for i in range(1, MAX_N):
    fact_inf[i] = inf_mul(i, fact_inf[i - 1])
    fact_mod[i] = mod_mul(i, fact_mod[i - 1])

def ways_inf (x):
    return inf_mul(fact_inf[x // 2], fact_inf[(x + 1) // 2])

def ways_mod (x):
    return mod_mul(fact_mod[x // 2], fact_mod [(x + 1) // 2])

def tot_ways_inf (x):
    if x % 2 == 0:
        return inf_mul(2, ways_inf(x - 2))
    else:
        return inf_mul(4, ways_inf(x - 2))

def tot_ways_mod (x):
    if x % 2 == 0:
        return mod_mul(2, ways_mod(x - 2))
    else:
        return mod_mul(4, ways_mod(x - 2))

def adj_sum (v):
    return sum([abs(v[i + 1] - v[i]) for i in range(len(v) - 1)])

def solve (N, idx):
    if N == 1:
        return [1]

    ans = []
    last = -1
    pref = 0
    choices = [[], []]
    special = False
    mode = 0
    if N % 2 == 0:
        if idx < ways_inf(N - 2):
            ans.append(N // 2)
            last = N // 2 + 1
            mode = 0
        else:
            ans.append(N // 2 + 1)
            last = N // 2
            pref += ways_inf(N - 2)
            mode = 1

        choices[0] = list(range(1, min(ans[0], last)))
        heapq.heapify(choices[0])
        choices[1] = list(range(max(ans[0], last) + 1, N + 1))
        heapq.heapify(choices[1])
    else:
        if idx < ways_inf(N - 2):
            ans.append(N // 2)
            last = N // 2 + 1
            mode = 0
        elif idx < 3 * ways_inf(N - 2):
            ans.append(N // 2 + 1)
            special = True
            pref += ways_inf(N - 2)
        else:
            ans.append(N // 2 + 2)
            last = N // 2 + 1
            pref += 3 * ways_inf(N - 2)
            mode = 1

        if not special:
            choices[0] = list(range(1, min(ans[0], last)))
            heapq.heapify(choices[0])
            choices[1] = list(range(max(ans[0], last) + 1, N + 1))
            heapq.heapify(choices[1])
        

    for i in range(1, N - 1):
        if special:
            for j in range(1, N + 1):
                if j != ans[0]:
                    if pref + ways_inf(N - 2 - i) <= idx:
                        pref += ways_inf(N - 2 - i)
                    else:
                        ans.append(j)
                        break
            if ans[1] > ans[0]:
                mode = 1
                last = ans[0] - 1
            else:
                mode = 0
                last = ans[0] + 1

            choices[0] = [i for i in range(1, min(ans[0], last)) if i != ans[1]]
            heapq.heapify(choices[0])
            choices[1] = [i for i in range(max(ans[0], last) + 1, N + 1) if i != ans[1]]
            heapq.heapify(choices[1])
            
            special = False
        else:
            mode = 1 - mode

            queue = []
            while True:
                add = heapq.heappop(choices[mode])
                if pref + ways_inf(N - 2 - i) <= idx:
                    pref += ways_inf(N - 2 - i)
                    queue.append(add)
                else:
                    ans.append(add)
                    break

            for u in queue:
                heapq.heappush(choices[mode], u)

    ans.append(last)
    return ans

fin = open("svejksis.txt", "r")
line = fin.readline().split()
length = int(line[0])
target = int(line[1])
fin.close()

fout = open("svejkval.txt", "w")
fout.write(str(adj_sum(solve(length, 0))))
fout.write(" ")
fout.write(str(tot_ways_mod(length)))
fout.write("\n")
fout.write(" ".join(map(str, solve(length, 0))))
fout.write("\n")
fout.write(" ".join(map(str, solve(length, target - 1))))
fout.write("\n")
fout.close()
