#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <bitset>
#include <cassert>
#include <string>
#include <algorithm>
#include <cstdlib>
using namespace std;

const int BEST_TESTS = 18; // TODO update this to the actual number in best submitted solution
const int MAX_TESTS = 100; // limit from task statement

namespace Checker{ //from ../gen/correct_solution.cpp
    typedef vector<int> vi;
    typedef vector<vi> vvi;
    typedef vector<vvi> vvvi;
#define all(v) (v).begin(), (v).end()
#define pb push_back
    const int K = 2, N = 112;
    vi find_partitions(){
        vi ans;
        for(int i = 0; i < (1<<(K*4)); ++i)
            if(__builtin_popcount(i) == 4)
                ans.pb(i);
        return ans;
    }
    int minutes(vi d){
        return d[0]*600+d[1]*60+d[2]*10+d[3];
    }
    bool valid_clock(vi d){
        if(d[0]*10 + d[1] >= 24) return false;
        if(d[2]*10 + d[3] >= 60) return false;
        return true;
    }
    vi solve_inner(vi d, int bm){
        sort(all(d));
        vvi perms;
        perms.pb({d[3],d[2],d[1],d[0]});
        perms.pb({d[2],d[3],d[1],d[0]});
        perms.pb({d[2],d[1],d[3],d[0]});
        perms.pb({d[2],d[1],d[0],d[3]});
        perms.pb({d[1],d[3],d[2],d[0]});
        perms.pb({d[1],d[3],d[0],d[2]});
        perms.pb({d[1],d[2],d[3],d[0]});
        perms.pb({d[1],d[2],d[0],d[3]});
        perms.pb({d[1],d[0],d[3],d[2]});
        perms.pb({d[1],d[0],d[2],d[3]});
        perms.pb({d[0],d[3],d[2],d[1]});
        perms.pb({d[0],d[3],d[1],d[2]});
        perms.pb({d[0],d[1],d[3],d[2]});
        perms.pb({d[0],d[1],d[2],d[3]});
        for(vi digits : perms){
            if(bm&1) if(valid_clock(digits)) return digits;
            bm >>= 1;
        }
        return {-1};
    }
    vi read_digits(string input){
        stringstream _input(input.c_str());
        vi digits;
        int x;
        while(_input >> x)
            digits.push_back(x);
        return digits;
    }
    string as_string(vi clock){
        assert(clock.size() == 4);
        string ans;
        ans.push_back(clock[0]+'0');
        ans.push_back(clock[1]+'0');
        ans.push_back(':');
        ans.push_back(clock[2]+'0');
        ans.push_back(clock[3]+'0');
        return ans;
    }
    string as_string(vvi clocks){
        assert(clocks.size() == K);
        string ans;
        for(int i = 0; i < K; ++i){
            if(ans.size())
                ans += " ";
            ans += as_string(clocks[i]);
        }
        return ans;
    }
    vi get_mask_digits(vi digits, int bm){
        assert(digits.size() == 4*K);
        vi ans;
        for(int i = 0; i < 4*K; ++i)
            if(bm&(1<<i))
                ans.pb(digits[i]);
        return ans;
    }
    string sol(string input, bitset<N> bm){
        vi digits = read_digits(input);
        int best_cost = -1;
        string best_ans = "-1";
        vi partitions = find_partitions();
        vi bm_perm_to_check(K);
        for(int i = 0; i < K; ++i)
            for(int j = 0; j < 14; ++j){
                bm_perm_to_check[i] |= (bm[0]<<j);
                bm >>= 1;
            }
        bitset<70> bm_choose;
        for(int i = 0; i < 70; ++i){
            bm_choose[i] = bm[0];
            bm >>= 1;
        }
        int count_p0 = -1;
        for(int p0 : partitions){
            ++count_p0;
            if(bm_choose[count_p0]){
                int p1 = ((1<<(K*4))-1)^p0;
                vvi used_digits(K);
                used_digits[0] = get_mask_digits(digits,p0);
                used_digits[1] = get_mask_digits(digits,p1);
                vvi cur_clocks(K);
                bool ok = true;
                for(int i = 0; i < K; ++i){
                    cur_clocks[i] = solve_inner(used_digits[i],bm_perm_to_check[i]);
                    if(cur_clocks[i].size() != 4)
                        ok = false;
                }
                if(!ok) continue;
                int cur_cost = 0;
                for(auto clock : cur_clocks) cur_cost += minutes(clock);
                string cur_ans = as_string(cur_clocks);
                if(cur_cost > best_cost || (cur_cost == best_cost && cur_ans > best_ans)){
                    best_ans = cur_ans;
                    best_cost = cur_cost;
                }
            }
        }
        return best_ans;
    }
    vector<bitset<N>> get_wrong_solutions(){
        vector<bitset<N>> wrong_solutions = { //taken from ../gen/wrong_bitmasks.txt
bitset<N>("1011111111111101111111111111101111111111111111110111111111111111101101011111111111111111111111111111111111111111"),
bitset<N>("1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111101111111111111111111111"),
bitset<N>("1111111111111101111111111111111111111111111111111110111111011111111011111111111111111111111111111111111111111111"),
bitset<N>("1011111111111111111111110111110101111110111101011110111111111111110111011111111111111111111111111111111111111111"),
bitset<N>("1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111011111111111"),
bitset<N>("1111111111110111110111101111011111111111111111111111111111111111111111111111111111111111011111111111111111111111"),
bitset<N>("1111111111111111111111111111111111111111111111111111111111111111111110111111111111111111110111111111111111111111"),
bitset<N>("1111111111111111111111111111111111111111011111111111111111111111111111111111111111111101111111111111111111111111"),
bitset<N>("1011111111111111111111111111111101111111111110111111110111111111111110011111111111111111111111111111111111111111"),
bitset<N>("1111111111011011111110111011101111101111111111111111111111111011111111111011111011100111111111111111111111111111"),
bitset<N>("1111111111111111110111111111111111111111111111111111111111111111011111110111111110101111111111111111111111111111"),
bitset<N>("1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111011111111111111111111"),
bitset<N>("1110111111111011111111101111111111111111111110111011111111111111110010111111111111110111111111111111111111111111"),
bitset<N>("1111111111101111111111111111101110111111111111101101111011011110011101111111111111111111111111111111111111111111"),
bitset<N>("1111111111101011011111111111111111101101110111111111111111111111111111100111010111011111111111111111111111111111"),
bitset<N>("1011111111111110111111111110011111111110110111110111111111111111111111111111111111110111111111111111111111111111"),
bitset<N>("1101111111111111111111111111011111111111111111111111101111111111111101111111111111111111111111111111111111111111"),
bitset<N>("1101111111111111101101111111111111111001111111111111101111111101111111111111101111111011111111111111111111111111"),
bitset<N>("1111111111111111011111111110111111111110111111111111110111111101011011110111111111011111111111111111111111111111"),
bitset<N>("1111111111111101111111011011111111111111111111111111111111111111111111111111111011111111111111111111111111111111"),
bitset<N>("1011101111111111111111111111111111111111011111111111111111111111111111111111111011111111111111111111111111111111"),
bitset<N>("1111111111111111111111111110111011111111111111111110111101111111111111101111101111111111111111111111111111111111"),
bitset<N>("1111111111111111111110111111111111111111111101111111111111111111111111111111111111110111111111111111111111111111"),
bitset<N>("0110111111111111111111111111111111111111111111101111111111111111111111101111111011111111110101111111111111111111"),
bitset<N>("1111011111110101111111111111011111111010111111111101110111110111100110110111101111111111111111111111111111111111"),
bitset<N>("1100111011111111111111111111110110111111111111111111111111111111111110111111111101111111111111111111111111111111"),
bitset<N>("1111101110111111111111111111111111111001111111110111111111111111111101111111111111111111111111111111111111111111"),
bitset<N>("1111111111111111111011110111111111111111111111111111111111111111111101110111110110111111111111111111111111111111"),
bitset<N>("1111111111111111111001111111111111111111111111111111111111111110111111111111111111111111111111111111111111111111"),
bitset<N>("1110111111111111111111111111111111111111111111111101111111111101111111111101111110111011111111111111111111111111"),
bitset<N>("1111111111111111111111011111111011111111011111111111101111111111111111111111111111111111111111111111111111111111"),
bitset<N>("1111111111111101111111111111111011111111111111111111111111111111111111111111111111111111111111111111111111111111"),
bitset<N>("1111111111111111111111110111111111110111111111110110111111111111111111111111111101111111111111111111111111111111"),
bitset<N>("1111111111111111111111011110111111111111111111111111111111111111111111111111111111111111111111111111111111111111"),
bitset<N>("1111111111111111111101111111111111111111110111111110111111111111110111111111111111111111111111111111111111111111"),
bitset<N>("1111111111111111111111111111111111111111111111111110111111111111111111110111111111111111111111111111111111111111"),
bitset<N>("1111111111110101111011111111111111111111111111110111111001111111101111111111001111111111111111111111111111111111"),
bitset<N>("1111011111111111111111111111111101111011101111111111111010011111111111111111110111110111111101111111111111111111"),
bitset<N>("1111111111111111111111111111111111111111101111111111111111111111111110111110110111111111111111111111111111111111"),
bitset<N>("1110111110111111111111101111110111111011111110011111111001111111111111111101111011111111111101111111111111111111"),
bitset<N>("1111111111111111111111111111111111111111111111111101111111110111111111111111110011111111111111111111111111111111"),
bitset<N>("1111111111111111011111111111111110111111101111111111110111110111111111111110111111111111111111111111111111111111"),
bitset<N>("1111111111111111111111111111111111111111111111111011111111111111111111110111000111111111111111111111111111111111"),
bitset<N>("1111111111111011011111111111111111111111101111111111111111111111111101111111111101111111111111111111111111111111"),
bitset<N>("1111111111111111111110111111111111101111111111111111111111111010111101111011110111111111111111111111111111111111"),
bitset<N>("1111000111111111111111101111011111111111111111010110111111111111111111101111111111111111111111111111111111111111"),
bitset<N>("1111111111111111111111011111111111111111111111101111111100111101111111111111111111111111111111111111111111111111"),
bitset<N>("1111111111111110111111111111111111011111111111111111111111111111111111111111111111111111111111111111111111111111"),
bitset<N>("1111111111111111111111111111111110111111111110111111111111111111111111111111111111111111111101111111111111111111"),
bitset<N>("1111111111111111111111111111111111011111111111111111111110111011111111011111111111111111111111111111111111111111"),
bitset<N>("1111111111101111011101111111111111111111111111111111111111111111111101111011111111011111111111111111111111111111"),
bitset<N>("1111111111111111111111111100111111111111111111111111111110111111111111111111111111111111111101111111111111111111"),
bitset<N>("1001111111111011111111111111011111111111111111111111111011111111011111111111111111111011111111111111111111111111"),
bitset<N>("1111010111111111111110110011110010110111110011111111111111101111011111111101110111101111111111111111111111111111"),
bitset<N>("1111011111111111111011111111111111101111111111110111111111011011111111110110111111111111111101111111111111111111"),
bitset<N>("1111101111111111111111111111111111111101111111111111111111111111101110111101011111111111111111111111111111111111"),
bitset<N>("1111111111111110111011111111111111111110011111111111111111111111111111111111111111110111111111111111111111111111"),
bitset<N>("1011111111111111111101100111111011111111111111111111111111110111101110111111101111110111111111111111111111111111"),
bitset<N>("1111111111111111111111111111111111111111111111111111111101111111111111110111111111111111111111111111111111111111"),
bitset<N>("1110101101111111111111011111110111111100110011111111111011111110110111110111110111110111111111111111111111111111"),
bitset<N>("1110111111111111111101110111111111100011111111111011011011111111100011100101111011111111111111111111111111111111"),
bitset<N>("1111111111011111111111111111111111111111111111111110111100111111110110111111111111111111111111111111111111111111"),
bitset<N>("1111111111101111111111111101111110111111110111110111101111111111110111111110111111111011111111111111111111111111"),
bitset<N>("1011111111101111010111101111111111101100111111101001111110111111110111111001111111111011111111111111111111111111"),
bitset<N>("1111111111111111110111011111111111111111111111111111101111111111111110111110011111111111111111111111111111111111"),
bitset<N>("1111111101111111011111011111111001011101111111111111111001111111111110111101111111111111111111111111111111111111"),
bitset<N>("1111111111111111111101111111111111111111111011111111111111111111111111111110111111111111111111111111111111111111"),
bitset<N>("0111111111111111111110111101111111011101011111101111101110110111111111111111111111010111111111111111111111111111"),
bitset<N>("1111110111111111111111111111110011111111111111110111111111111111111111010111111111011111111111111111111111111111"),
bitset<N>("1011111101011101111010111101111111111111011111111101111111111111111111111111111011111111111101111111111111111111"),
bitset<N>("1111111111111111111110111111011111111111111111111111111111111111101111111111111111111111111111111111111111111111"),
bitset<N>("1111111111111111111111111111111111111111111111111111111111111111111111011111111110111111111111111111111111111111"),
bitset<N>("1110111111111111111111111111111111111001111111111111101111111111111111011101011110111111111111111111111111111111"),
bitset<N>("1111111011111111111111101110111111111011111111111111101111111111111111111011010111111111111111111111111111111111"),
bitset<N>("1111111111111101111111011011111111111111111111111111111111111001111111111111111111111111111111111111111111111111"),
bitset<N>("1111111111111111110111111111111111111101110011111111111111111111111111111011111111111111111111111111111111111111"),
bitset<N>("1111111111111111111111111101111111110110110101101110111111111101111111111111111010111111111111111111111111111111"),
bitset<N>("1111111110111100011111011111111111110011101111101111111111111010111011111111111101101111111111111111111111111111"),
bitset<N>("1111111011111110010011111111101011101111011111101001111101111111101111101111110111111111111111111111111111011111"),
bitset<N>("1111111111111111111111111110111111111111111111111011111011110010111111101111110111111111111111111111111111111111"),
bitset<N>("1111111111111111111111111111111111011111111111111111111111111111111111111111111101101111111111111111111111111111"),
bitset<N>("1111111110111111111111111111111111111111111111111011111011111111111111101110111111111111111111111111111111111111"),
bitset<N>("1111111111111111111111111111111111111111111111111111111111101111110111111011111111111111111111111111111111111111"),
bitset<N>("1101111111110111110111111111111111101111101101000111111111111111111111111111111111111111111111111111111111111111"),
bitset<N>("0111111111111101101111010111111111011111111111111111110111111111111111111111111011111111111111111111111111111111"),
bitset<N>("1111111111101011101111111011110011111111001111111111111101111101111111111101111011111111111111111111111111011111"),
bitset<N>("0111111111110100111111101011111111111111111111110111111111111111101111111111111111111111111111111111111111111111"),
bitset<N>("1111111111011111001111111111111111111111110111111101110101111110111111111111010111111111111111111111111111111111"),
bitset<N>("1111111111011111111111110110111111111111011111111110111111110111111111111111111111111111111111111111111111111111"),
bitset<N>("1111110111111011101101111110110111111111101111111111111111101101101111111111111111111111111111111111111111111111"),
bitset<N>("1110111111111111111101111111011111111111111111101101111011111111111111110111101010111111111111111111111111111111"),
bitset<N>("1111111111011111111011110111111101111110111110111111111111111111011111111111111111111111111111111111111111111111"),
bitset<N>("0111111111111111011011111010110011111111111111111101111011111110100111111010110011111111111111111111111111111111"),
bitset<N>("1111111111111111111110111110101111111111111111111111111110111111101101111111111110111111111111111111111111111111"),
bitset<N>("1111111111111101111111111111000011111111111111011111111111111111111111111111111111111011111101111111111111011111"),
bitset<N>("1111111111110011011111111111111111011111111011011111111101011111111111011111101111110111111101111111111111111111"),
bitset<N>("1110111111111111111111111111111111111111111101111111111111111110111111111110001111111111111111111111111111111111"),
bitset<N>("1111100111111111011111111110011111111111111111101111111111111110111101111111111111111111111111111111111111111111"),
bitset<N>("1110111110111110111111011111101111110110111111111111101011111111111111101111011111010111111111111111111111011111"),
bitset<N>("1111111101110111111111111111111111111111111111111111111111111111111111010111111110101111111111111111111111111111")};
        return wrong_solutions;
    }
    double check_solution(vvi tests){
        vector<bitset<N>> wrong_solutions = get_wrong_solutions();
        int n = tests.size();
        int failed = 0; // failed solutions
        vector<string> correct_answers(n);
        vector<string> input_strings(n);
        for(int i = 0; i < n; ++i){
            string input_string;
            for(int digit : tests[i]){
                if(input_string.size())
                    input_string += " ";
                input_string += to_string(digit);
            }
            input_strings[i] = input_string;
        }
        for(int i = 0; i < n; ++i){
            bitset<N> full;
            full.flip();
            correct_answers[i] = sol(input_strings[i],full);
        }
        for(bitset<N> bitmask : wrong_solutions){
            bool has_failed = false;
            for(int i = 0; i < n; ++i){
                string cur_answer = sol(input_strings[i],bitmask);
                if(cur_answer != correct_answers[i]){
                    has_failed = true;
                    break;
                }
            }
            if(has_failed)
                ++failed;
        }
        return double(failed) / wrong_solutions.size();
    }
}

void done(double score, string message) {
    cout << score << "\n";
    cerr << message << "\n";
    exit(0);
}

int main(int argc, const char *argv[]) {
    if (argc != 4) {
        cerr << "Usage: " << argv[0] << " input_file hint_file output_file\n";
        cerr << "Note that there are actually no input or hint files in this task,\n";
        cerr << "but the CMS interface insists on this parameter order; just give\n";
        cerr << "any junk as two first parameters when testing manually\n";
        return 0;
    }
    string s, t;

    ifstream out(argv[3]);
    if (!out) {
        done(0, "Invalid output file");
    }

    int n;
    if(!getline(out, s)){
        done(0, "Wrong output format on line 1");
    }
    istringstream ss(s);
    ss >> n;
    if(!ss || ss >> t){
        done(0, "Wrong output format on line 1");
    }
    if(n < 0 || n > MAX_TESTS){
        done(0, "Invalid number of tests");
    }

    vector< vector<int> > tests(n);
    for(int i = 0; i < n; ++i){
        if(!getline(out, s)){
            done(0, "Wrong output format on line " + to_string(2 + i));
        }
        istringstream ss(s);
        tests[i].resize(8);
        for(int j = 0; j < 8; ++j){
            ss >> tests[i][j];
            if(!ss || tests[i][j] < 0 || tests[i][j] > 9){
                break;
            }
        }
        if(!ss || ss >> t){
            done(0, "Wrong output format on line " + to_string(2 + i));
        }
    }
    if(out >> t){
        done(0, "Wrong output format on line " + to_string(2 + n));
    }

    double ratio = 0;
    try{
        ratio = Checker::check_solution(tests);
    }catch(...){
        //BAD! Checker error, not contestant error.
        done(0, "Something went wrong!");
    }

    if (ratio < 1) {
        done(0.5 * ratio, "OK (some wrong solutions passed)");
    } else {
        done(0.5 + 0.5 * BEST_TESTS / n, "OK (all wrong solutions failed)");
    }
    return 0;
}
