#include <iostream>
#include <sstream>
#include <fstream>
#include <set>
#include <vector>
#include <cassert>
#include <bitset>
#include <algorithm>
using namespace std;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
#define all(v) (v).begin(), (v).end()
#define pb push_back
const int K = 2, N = 112;
vi find_partitions(){
    vi ans;
    for(int i = 0; i < (1<<(K*4)); ++i)
        if(__builtin_popcount(i) == 4)
            ans.pb(i);
    return ans;
}
int minutes(vi d){
    return d[0]*600+d[1]*60+d[2]*10+d[3];
}
bool valid_clock(vi d){
    if(d[0]*10 + d[1] >= 24) return false;
    if(d[2]*10 + d[3] >= 60) return false;
    return true;
}
vi solve_inner(vi d, int bm){
    sort(all(d));
    vvi perms;
    perms.pb({d[3],d[2],d[1],d[0]});
    perms.pb({d[2],d[3],d[1],d[0]});
    perms.pb({d[2],d[1],d[3],d[0]});
    perms.pb({d[2],d[1],d[0],d[3]});
    perms.pb({d[1],d[3],d[2],d[0]});
    perms.pb({d[1],d[3],d[0],d[2]});
    perms.pb({d[1],d[2],d[3],d[0]});
    perms.pb({d[1],d[2],d[0],d[3]});
    perms.pb({d[1],d[0],d[3],d[2]});
    perms.pb({d[1],d[0],d[2],d[3]});
    perms.pb({d[0],d[3],d[2],d[1]});
    perms.pb({d[0],d[3],d[1],d[2]});
    perms.pb({d[0],d[1],d[3],d[2]});
    perms.pb({d[0],d[1],d[2],d[3]});
    for(vi digits : perms){
        if(bm&1) if(valid_clock(digits)) return digits;
        bm >>= 1;
    }
    return {-1};
}
vi read_digits(string input){
    stringstream _input(input.c_str());
    vi digits;
    int x;
    while(_input >> x)
        digits.push_back(x);
    return digits;
}
string as_string(vi clock){
    assert(clock.size() == 4);
    string ans;
    ans.push_back(clock[0]+'0');
    ans.push_back(clock[1]+'0');
    ans.push_back(':');
    ans.push_back(clock[2]+'0');
    ans.push_back(clock[3]+'0');
    return ans;
}
string as_string(vvi clocks){
    assert(clocks.size() == K);
    string ans;
    for(int i = 0; i < K; ++i){
        if(ans.size())
            ans += " ";
        ans += as_string(clocks[i]);
    }
    return ans;
}
vi get_mask_digits(vi digits, int bm){
    assert(digits.size() == 4*K);
    vi ans;
    for(int i = 0; i < 4*K; ++i)
        if(bm&(1<<i))
            ans.pb(digits[i]);
    return ans;
}
string sol(string input, bitset<N> bm){
    vi digits = read_digits(input);
    int best_cost = -1;
    string best_ans = "-1";
    vi partitions = find_partitions();
    vi bm_perm_to_check(K);
    for(int i = 0; i < K; ++i)
        for(int j = 0; j < 14; ++j){
            bm_perm_to_check[i] |= (bm[0]<<j);
            bm >>= 1;
        }
    bitset<70> bm_choose;
    for(int i = 0; i < 70; ++i){
        bm_choose[i] = bm[0];
        bm >>= 1;
    }
    int count_p0 = -1;
    for(int p0 : partitions){
        ++count_p0;
        if(bm_choose[count_p0]){
            int p1 = ((1<<(K*4))-1)^p0;
            vvi used_digits(K);
            used_digits[0] = get_mask_digits(digits,p0);
            used_digits[1] = get_mask_digits(digits,p1);
            vvi cur_clocks(K);
            bool ok = true;
            for(int i = 0; i < K; ++i){
                cur_clocks[i] = solve_inner(used_digits[i],bm_perm_to_check[i]);
                if(cur_clocks[i].size() != 4)
                    ok = false;
            }
            if(!ok) continue;
            int cur_cost = 0;
            for(auto clock : cur_clocks) cur_cost += minutes(clock);
            string cur_ans = as_string(cur_clocks);
            if(cur_cost > best_cost || (cur_cost == best_cost && cur_ans > best_ans)){
                best_ans = cur_ans;
                best_cost = cur_cost;
            }
        }
    }
    return best_ans;
}
void solve_using(bitset<N> bm){
    string input;
    getline(cin,input);
    cout << sol(input,bm) << '\n';
}
int main(){
    bitset<N> bm;
    bm.flip();
    solve_using(bm);
}
