#include <iostream>
#include <sstream>
#include <fstream>
#include <set>
#include <vector>
#include <cassert>
#include <bitset>
#include <algorithm>
using namespace std;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
#define all(v) (v).begin(), (v).end()
#define pb push_back
const int K = 2, N = 112; //70+14*3 = C(8,4)+(count_useful_perm)*3
ostream &operator<<(ostream &stream, const vi &vec){
    for(int i = 0; i < vec.size(); ++i){
        if(i) stream << ' ';
        stream << vec[i];
    }
    return stream;
}
vi find_partitions(){
    vi ans;
    for(int i = 0; i < (1<<(K*4)); ++i)
        if(__builtin_popcount(i) == 4)
            ans.pb(i);
    return ans;
}
int minutes(vi d){
    return d[0]*600+d[1]*60+d[2]*10+d[3];
}
bool valid_clock(vi d){
    if(d[0]*10 + d[1] >= 24) return false;
    if(d[2]*10 + d[3] >= 60) return false;
    return true;
}
vi solve_inner(vi d, int bm){
    sort(all(d));
    vvi perms;
    perms.pb({d[3],d[2],d[1],d[0]});
    perms.pb({d[2],d[3],d[1],d[0]});
    perms.pb({d[2],d[1],d[3],d[0]});
    perms.pb({d[2],d[1],d[0],d[3]});
    perms.pb({d[1],d[3],d[2],d[0]});
    perms.pb({d[1],d[3],d[0],d[2]});
    perms.pb({d[1],d[2],d[3],d[0]});
    perms.pb({d[1],d[2],d[0],d[3]});
    perms.pb({d[1],d[0],d[3],d[2]});
    perms.pb({d[1],d[0],d[2],d[3]});
    perms.pb({d[0],d[3],d[2],d[1]});
    perms.pb({d[0],d[3],d[1],d[2]});
    perms.pb({d[0],d[1],d[3],d[2]});
    perms.pb({d[0],d[1],d[2],d[3]});
    for(vi digits : perms){
        if(bm&1) if(valid_clock(digits)) return digits;
        bm >>= 1;
    }
    return {-1};
}
vi read_digits(string input){
    stringstream _input(input.c_str());
    vi digits;
    int x;
    while(_input >> x)
        digits.push_back(x);
    return digits;
}
string as_string(vi clock){
    assert(clock.size() == 4);
    string ans;
    ans.push_back(clock[0]+'0');
    ans.push_back(clock[1]+'0');
    ans.push_back(':');
    ans.push_back(clock[2]+'0');
    ans.push_back(clock[3]+'0');
    return ans;
}
string as_string(vvi clocks){
    assert(clocks.size() == K);
    string ans;
    for(int i = 0; i < K; ++i){
        if(ans.size())
            ans += " ";
        ans += as_string(clocks[i]);
    }
    return ans;
}
vi get_mask_digits(vi digits, int bm){
    assert(digits.size() == 4*K);
    vi ans;
    for(int i = 0; i < 4*K; ++i)
        if(bm&(1<<i))
            ans.pb(digits[i]);
    return ans;
}
string sol(string input, bitset<N> bm){
    vi digits = read_digits(input);
    int best_cost = -1;
    string best_ans = "-1";
    vi partitions = find_partitions();
    vi bm_perm_to_check(K);
    int bits = 0;
    for(int i = 0; i < K; ++i)
        for(int j = 0; j < 14; ++j){
            bm_perm_to_check[i] |= (bm[0]<<j);
            bm >>= 1;
        }
    bitset<70> bm_choose;
    for(int i = 0; i < 70; ++i){
        bm_choose[i] = bm[0];
        bm >>= 1;
    }
    int count_p0 = -1;
    for(int p0 : partitions){
        ++count_p0;
        if(bm_choose[count_p0]){
            int p1 = ((1<<(K*4))-1)^p0;
            assert(__builtin_popcount(p1) == 4);
            vvi used_digits(K);
            used_digits[0] = get_mask_digits(digits,p0);
            used_digits[1] = get_mask_digits(digits,p1);
            vvi cur_clocks(K);
            bool ok = true;
            for(int i = 0; i < K; ++i){
                cur_clocks[i] = solve_inner(used_digits[i],bm_perm_to_check[i]);
                if(cur_clocks[i].size() != 4)
                    ok = false;
            }
            if(!ok) continue;
            int cur_cost = 0;
            for(auto clock : cur_clocks) cur_cost += minutes(clock);
            string cur_ans = as_string(cur_clocks);
            if(cur_cost > best_cost || cur_cost == best_cost && cur_ans > best_ans){
                best_ans = cur_ans;
                best_cost = cur_cost;
            }
        }
    }
    return best_ans;
}
string vi_to_string(vi a){
    string ans;
    for(int x : a){
        if(ans.size())
            ans.pb(' ');
        ans.pb(x+'0');
    }
    return ans;
}
vector<string> gen_random_tests(int n){
    //for more interesting tests: 
    //  1) no reason to use {6,7,8}
    //  2) more weight to small digits
    vi useful_digits = {0,0,0,1,1,1,2,2,2,3,4,5,9};
    vector<string> ans;
    for(int times = 0; times < n; ++times){
        vi cur;
        for(int i = 0; i < 4*K; ++i)
            cur.pb(useful_digits[rand()%useful_digits.size()]);
        ans.pb(vi_to_string(cur));
    }
    return ans;
}
int main(int argc, char *argv[]){
    assert(argc == 4);
    string output_file_name = argv[1];
    int n_solutions = atoi(argv[2]);
    int n_choose_from = atoi(argv[3]);
    ofstream fout(output_file_name);
    bitset<N> full;
    full.flip();
    vector<string> tests = gen_random_tests(n_choose_from);
    vector<string> answers;
    for(auto _ : tests){
        answers.pb(sol(_,full));
        fout << _ << '\n';
    }
    for(auto _ : answers)
        fout << _ << '\n';
    set<vi> wrong_sets;
    for(int i = 0; i < n_solutions; ++i){
        srand(i+666);
        bitset<N> bm = full;
        int cnt_wrong = 0;
        vi wrong_tests;
        while(true){
            cnt_wrong = 0;
            wrong_tests.clear();
            int r = rand()%N;
            bm[r] = 0;
            string results;
            for(int i = 0; i < tests.size(); ++i){
                if(sol(tests[i],bm) != answers[i]){
                    results += "0";
                    cnt_wrong += 1;
                    wrong_tests.pb(i);
                }
                else
                    results += "1";
            }
            if(cnt_wrong > 10 || wrong_sets.count(wrong_tests)){
                cnt_wrong = 0;
                bm.reset();
                bm.flip();
            }
            if(cnt_wrong){
                wrong_sets.insert(wrong_tests);
                break;
            }
        }
        cout << i << ' ' << cnt_wrong << ' ' << wrong_tests << endl;
        fout << bm << '\n' << cnt_wrong << ' ' << wrong_tests << endl;
    }
}
