#include <bits/stdc++.h>
#include <unordered_map>

#define ll long long

using namespace std;

ll gcd(ll a, ll b)
{
    if(a < 0)
    {
        return gcd(-a, b);
    }
    if(b < 0)
    {
        return gcd(a, -b);
    }
    if(a < b)
    {
        return gcd(b, a);
    }
    if(b == 0)
    {
        return a;
    }
    return gcd(b, a % b);
}

ll lcm(ll a, ll b)
{
    return (a * b) / gcd(a, b);
}

class rational
{
public:
    ll nom;
    ll den;
    void eq()
    {
        ll x = gcd(nom, den);
        nom /= x;
        den /= x;
    }
    ll flr()
    {
        return nom / den;
    }
    void operator =(rational b)
    {
        nom = b.nom;
        den = b.den;
    }
};

rational operator +(rational a, rational b)
{
    ll x = lcm(a.den, b.den);
    rational c;
    c.nom = 0;
    c.den = x;
    ll mlta = x / a.den;
    ll mltb = x / b.den;
    c.nom += a.nom * mlta;
    c.nom += b.nom * mltb;
    c.eq();
    return c;
}

rational operator -(rational a, rational b)
{
    rational c;
    c.nom = -b.nom;
    c.den = b.den;
    return a + c;
}

rational operator *(rational a, rational b)
{
    rational c;
    c.nom = a.nom * b.nom;
    c.den = a.den * b.den;
    c.eq();
    return c;
}

rational operator /(rational a, rational b)
{
    rational c;
    c.nom = b.den;
    c.den = b.nom;
    return a * c;
}

bool operator < (rational a, rational b)
{
    ll f = a.nom * b.den;
    ll s = a.den * b.nom;
    return f < s;
}

bool operator > (rational a, rational b)
{
    return b < a;
}

bool operator ==(rational a, rational b)
{
    return (!(a > b) && !(a < b));
}

bool operator < (rational a, ll b)
{
    ll c = b * a.den;
    return a.nom < c;
}

bool operator > (rational a, ll b)
{
    ll c = b * a.den;
    return a.nom > c;
}

bool operator < (ll a, rational b)
{
    return b > a;
}

bool operator > (ll a, rational b)
{
    return b < a;
}

ll mod = 1e9+7;
ll n, m, p, q, s;
rational pr, qr, sr;
rational rt; //rt = sqrt(S/(p^2+q^2))

ll sqt(ll a)
{
    ll lb = 0;
    ll ub = mod;
    while(lb <= ub)
    {
        ll mb = (lb + ub) / 2;
        if(mb * mb > a)
        {
            ub = mb - 1;
            continue;
        }
        if(mb * mb < a)
        {
            lb = mb + 1;
            continue;
        }
        return mb;
    }
    a /= 0; //kui pole tisruut -> error
    return a;
}

rational sqt(rational a)
{
    rational b;
    b.nom = sqt(a.nom);
    b.den = sqt(a.den);
    return b;
}

ll nos(ll w, ll h) //Tkkide arv w*h jupis, kus all vasakust nurgast tuleb vanaema lige
{
    rational one;
    one.nom = 1;
    one.den = 1;
    unordered_map<ll, ll> mp;
    ll sub = 0;
    ll vas = w * h;
    vas %= mod;
    rational p2 = pr * pr;
    rational q2 = qr * qr;
    rational step = p2 + q2;
    step = step * rt;
    rational step1 = step / qr;
    rational step2 = step / pr;
    ll tlk = rt.nom;
    rational x;
    x.nom = 0;
    x.den = 1;
    rational y;
    y.nom = 0;
    y.den = 1;
    ll ctr = 0;
    while(x < w)
    {
        rational jalgus = x / step2;
        ll lbegin = jalgus.flr();
        rational px = x;
        while(x.den != 1 && x < w && y < h)
        {
            y = y + one;
            ll og = x.flr();
            x = x + (pr/qr);
            ll dst = x.flr();
            if(x.den == 1)
            {
                dst--;
            }
            if(dst >= w)
            {
                dst = w - 1;
            }
            dst -= og;
            dst++;
            vas += dst;
            vas %= mod;
        }
        ll ny = tlk*ctr;
        ll dfy = ny - y.nom;
        dfy /= q;
        ll dfx = dfy * p;
        ll nx = x.nom + dfx;
        if(nx <= w && ny <= h)
        {
            ll dfv = p + q - 1;
            dfv *= dfy;
            dfv %= mod;
            vas += dfv;
            vas %= mod;
            y.nom = ny;
            x.nom += dfx;
            if(y > 0)
            {
                sub++;
            }
        }
        if(x.nom < w && y.nom < h)
        {
            rational xd;
            xd.nom = w - x.nom;
            xd.den = p;
            xd.eq();
            rational yd;
            yd.nom = h - y.nom;
            yd.den = q;
            yd.eq();
            ll num = min(xd.nom / xd.den, yd.nom / yd.den);
            ll dfv = p + q - 1;
            dfv *= num;
            dfv %= mod;
            vas += dfv;
            vas %= mod;
            ll sb = num / tlk;
            ll nsb = sb * tlk;
            if((nsb * p) + x.nom == w || (nsb * q) + y.nom == h)
            {
                sb--;
            }
            if(x.nom < w && y.nom < h)
            {
                sub += sb;
            }
            x.nom += num * p;
            y.nom += num * q;
        }
        while(x < w && y < h)
        {
            y = y + one;
            ll og = x.flr();
            x = x + (pr/qr);
            ll dst = x.flr();
            if(x.den == 1)
            {
                dst--;
            }
            if(dst >= w)
            {
                dst = w - 1;
            }
            dst -= og;
            dst++;
            vas += dst;
            vas %= mod;
        }
        if(x > w)
        {
            rational nx;
            nx.nom = w;
            nx.den = 1;
            rational xsb = x - nx;
            rational ysb = xsb * qr;
            ysb = ysb / pr;
            y = y - ysb;
            x = nx;
        }
        rational jlopp = (x / step2) + (y / step1);
        ll lend = jlopp.flr();
        if(jlopp.den == 1)
        {
            lend--;
        }
        ll sfty = lend - lbegin;
        if(sfty < 0)
        {
            sfty = 0;
        }
        vas += sfty;
        vas %= mod;
        x = px;
        y.nom = 0;
        y.den = 1;
        x = x + step1;
        ctr++;
    }
    x.nom = 0;
    x.den = 1;
    y = step2;
    ctr = 1;
    while(y < h)
    {
        rational jalgus = y / step1;
        ll lbegin = jalgus.flr();
        rational py = y;
        while(y.den != 1 && x < w && y < h)
        {
            x = x + one;
            ll og = y.flr();
            y = y + (qr/pr);
            ll dst = y.flr();
            if(y.den == 1)
            {
                dst--;
            }
            if(dst >= h)
            {
                dst = h - 1;
            }
            dst -= og;
            dst++;
            vas += dst;
            vas %= mod;
        }
        ll nx = tlk*ctr;
        ll dfx = nx - x.nom;
        dfx /= p;
        ll dfy = dfx * q;
        ll ny = y.nom + dfy;
        if(nx <= w && ny <= h)
        {
            ll dfv = p + q - 1;
            dfv *= dfx;
            dfv %= mod;
            vas += dfv;
            vas %= mod;
            y.nom = ny;
            x.nom += dfx;
            if(x > 0)
            {
                sub++;
            }
        }
        if(x.nom < w && y.nom < h)
        {
            rational xd;
            xd.nom = w - x.nom;
            xd.den = p;
            xd.eq();
            rational yd;
            yd. nom = h - y.nom;
            yd.den = q;
            yd.eq();
            ll num = min(xd.nom / xd.den, yd.nom / yd.den);
            ll dfv = p + q - 1;
            dfv *= num;
            dfv %= mod;
            vas += dfv;
            vas %= mod;
            ll sb = num / tlk;
            ll nsb = sb * tlk;
            if((nsb * p) + x.nom == w || (nsb * q) + y.nom == h)
            {
                sb--;
            }
            if(x.nom < w && y.nom < h)
            {
                sub += sb;
            }
            x.nom += num * p;
            y.nom += num * q;
        }
        while(x < w && y < h)
        {
            x = x + one;
            ll og = y.flr();
            y = y + (qr/pr);
            ll dst = y.flr();
            if(y.den == 1)
            {
                dst--;
            }
            if(dst >= h)
            {
                dst = h - 1;
            }
            dst -= og;
            dst++;
            vas += dst;
            vas %= mod;
        }
        if(y > h)
        {
            rational ny;
            ny.nom = h;
            ny.den = 1;
            rational ysb = y - ny;
            rational xsb = ysb * pr;
            xsb = xsb / qr;
            y = y - ysb;
            x = x - xsb;
        }
        rational jlopp = (x / step2) + (y / step1);
        ll lend = jlopp.flr();
        if(jlopp.den == 1)
        {
            lend--;
        }
        ll sfty = lend - lbegin;
        if(sfty < 0)
        {
            sfty = 0;
        }
        vas += sfty;
        vas %= mod;
        y = py;
        x.nom = 0;
        y = y + step2;
        ctr++;
    }
    x.nom = 0;
    x.den = 1;
    y.nom = 0;
    y.den = 1;
    while(y < h + 1)
    {
        if(y > h)
        {
            break;
        }
        rational py = y;
        while(y.den != 1 && x < w && y > 0)
        {
            x = x + one;
            ll og = y.flr();
            ll sb = 0;
            if(y.den == 1)
            {
                sb = 1;
            }
            y = y - (pr/qr);
            ll dst = y.flr();
            og -= sb;
            if(dst < 0)
            {
                dst = 0;
            }
            dst -= og;
            dst = -dst;
            dst++;
            vas += dst;
            vas %= mod;
        }
        if(x.nom < w && y.nom > 0)
        {
            rational xd;
            xd.nom = w - x.nom;
            xd.den = q;
            xd.eq();
            rational yd;
            yd.nom = y.nom;
            yd.den = p;
            yd.eq();
            ll num = min(xd.nom / xd.den, yd.nom / yd.den);
            ll dfv = p + q - 1;
            dfv *= num;
            dfv %= mod;
            vas += dfv;
            vas %= mod;
            x.nom += num * q;
            y.nom -= num * p;
        }
        while(x < w && y > 0)
        {
            x = x + one;
            ll og = y.flr();
            ll sb = 0;
            if(y.den == 1)
            {
                sb = 1;
            }
            y = y - (pr/qr);
            ll dst = y.flr();
            og -= sb;
            if(dst < 0)
            {
                dst = 0;
            }
            dst -= og;
            dst = -dst;
            dst++;
            vas += dst;
            vas %= mod;
        }
        y = py;
        x.nom = 0;
        y = y + step1;
    }
    rational hr;
    hr.nom = h;
    hr.den = 1;
    rational yalla = y - hr;
    rational xparemale = yalla*qr;
    xparemale = xparemale / pr;
    x = xparemale;
    y.nom = h;
    y.den = 1;
    while(x < w)
    {
        rational px = x;
        while(x.den != 1 && x < w && y > 0)
        {
            y = y - one;
            ll og = x.flr();
            x = x + (qr/pr);
            ll dst = x.flr();
            if(x.den == 1)
            {
                dst--;
            }
            if(dst >= w)
            {
                dst = w - 1;
            }
            dst -= og;
            dst++;
            vas += dst;
            vas %= mod;
        }
        if(x.nom < w && y.nom > 0)
        {
            rational xd;
            xd.nom = w - x.nom;
            xd.den = q;
            xd.eq();
            rational yd;
            yd.nom = y.nom;
            yd.den = p;
            yd.eq();
            ll num = min(xd.nom / xd.den, yd.nom / yd.den);
            ll dfv = p + q - 1;
            dfv *= num;
            dfv %= mod;
            vas += dfv;
            vas %= mod;
            x.nom += num * q;
            y.nom -= num * p;
        }
        while(x < w && y > 0)
        {
            y = y - one;
            ll og = x.flr();
            x = x + (qr/pr);
            ll dst = x.flr();
            if(x.den == 1)
            {
                dst--;
            }
            if(dst >= w)
            {
                dst = w - 1;
            }
            dst -= og;
            dst++;
            vas += dst;
            vas %= mod;
        }
        x = px;
        y.nom = h;
        x = x + step2;
    }
    vas -= sub;
    vas %= mod;
    vas += mod;
    vas %= mod;
    return vas;
}

int main()
{
    cin >> m >> n >> s >> p >> q;
    rational sr;
    sr.nom = s;
    sr.den = 1;
    qr.nom = q;
    qr.den = 1;
    pr.nom = p;
    pr.den = 1;
    rational p2 = pr * pr;
    rational q2 = qr * qr;
    rational sm = p2 + q2;
    rt = sr / sm;
    rt = sqt(rt);
    rational kp = sm * rt;
    ll side = kp.nom;
    ll a1 = nos(side, side);
    ll a2 = nos(side, n % side);
    ll a3 = nos(m % side, side);
    ll a4 = nos(m % side, n % side);
    ll N = n / side;
    ll M = m / side;
    ll vas = 0;
    vas += a1;
    vas *= N;
    vas %= mod;
    vas *= M;
    vas %= mod;
    ll jl = a2 * M;
    jl %= mod;
    vas += jl;
    vas %= mod;
    jl = a3*N;
    jl %= mod;
    vas += jl;
    vas %= mod;
    vas += a4;
    vas %= mod;
    cout << vas << endl;
    cin >> vas;
}
